#-----------------------------------------------------------------------------
# LockUnlock
# Copyright (c) 2004 David G. Drumright (Ockham)
# Oct. 5, 2004
# Lock or unlock selected body parts.
#-----------------------------------------------------------------------------

from Tkinter import *
import poser
scene = poser.Scene()
TheFig=scene.CurrentFigure()

#-----------------------------------------------------------------------------
def UnLock(ActorName):
    if TheFig:
        OneActor=TheFig.Actor(ActorName)
    else:
        OneActor=scene.Actor(ActorName)
    OneActor.SetStatic(0)
#-----------------------------------------------------------------------------
def Lock(ActorName):
    if TheFig:
        OneActor=TheFig.Actor(ActorName)
    else:
        OneActor=scene.Actor(ActorName)
    OneActor.SetStatic(1)
#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Lock or unlock")

        self.Labelbox = Label(self.master,text="Highlight parts in list, then hit Lock or Unlock").grid(row=1, column=0,columnspan=3)

        # Lists
        self.ListScroll = Scrollbar(self.master, orient=VERTICAL)
        self.ListScroll.grid( row=2, column=0,sticky=N+S+E)
        self.List = Listbox(self.master, height=25, selectmode=MULTIPLE,yscrollcommand = self.ListScroll.set)
        self.List.grid( row=2, column=1)
        # Set the scrollbar to work
        self.ListScroll["command"] = self.List.yview
        # Fill list with all body parts in selected figure or props
        if TheFig:
            for OneActor in TheFig.Actors():
                Name=OneActor.Name()
                self.List.insert(END,Name)
        else:
            for OneActor in scene.Actors():
                if (OneActor.IsProp()) and ( OneActor.Name() != 'GROUND'):
                    Name=OneActor.Name()
                    self.List.insert(END,Name)

        # Go/nogo buttons.
        self.buttonLock = Button(self.master, text="Lock", command=self.HandleLock)
        self.buttonLock.grid(row=3, column=0)
        self.buttonUnLock = Button(self.master, text="Unlock", command=self.HandleUnLock)
        self.buttonUnLock.grid(row=3, column=1)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleLock(self):
        # Go through selected items.  For each, set it to Locked
        Sels=self.List.curselection()
        if not Sels:  # Do all in list
            for OneIndex in range(self.List.size()):
                ActorName=self.List.get(OneIndex)
                Lock(ActorName)
        else: # Sels
            for OneIndex in Sels:
                ActorName=self.List.get(int(OneIndex))
                Lock(ActorName)
        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -
    def HandleUnLock(self):
        # Go through selected items.  For each, set it to Locked
        Sels=self.List.curselection()
        if not Sels:  # Do all in list
            for OneIndex in range(self.List.size()):
                ActorName=self.List.get(OneIndex)
                Lock(ActorName)
        else: # Sels
            for OneIndex in Sels:
                ActorName=self.List.get(int(OneIndex))
                UnLock(ActorName)
        self.master.destroy()
    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
